flipperDialog = {

  
  myUrlFlipper: null,
  myBrowser: null,
  myRDF: null,
  myDS: null,

  IOService: function() 
  {

    return Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);

  },

  IProperties: function()
  {

    return Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);

  },
  
  ILocalFile: function()
  {
    return Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
  },
  
  IFileProtocolHandler: function() 
  {
    return this.IOService().getProtocolHandler('file').QueryInterface(Components.interfaces.nsIFileProtocolHandler);
  },

  IURI: function()
  {
    return Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);

  },

  IWebBrowserPersist: function()
  {
     return Components.classes['@mozilla.org/embedding/browser/nsWebBrowserPersist;1'].createInstance(Components.interfaces.nsIWebBrowserPersist);

  },

  getRdf: function () 
  {

    var uri = "";

    // get ProfileDirectory
    const DIR = this.IProperties();
    var dir = DIR.get('ProfD', Components.interfaces.nsILocalFile);


    // get URI
    var tempLocalFile = this.ILocalFile();
    tempLocalFile.initWithPath(dir.path);


    uri = this.IOService().newFileURI(tempLocalFile).spec;

    if (!uri.match(/\/$/)) uri += '/';
    uri += 'flipper.rdf';
 
    var fileHandler = this.IFileProtocolHandler();
    tempLocalFile =  fileHandler.getFileFromURLSpec(uri);
 
    if ( !tempLocalFile.exists() ) {
      try {
        // Got this idea from a message of Matt Kennedy
        // to the Mozilla mailing list, I believe...

        // First we prepare the output stream...
        const FILE_OUTPUT_STREAM = "@mozilla.org/network/file-output-stream;1";
        const nsIFileOutputStream = Components.interfaces.nsIFileOutputStream;
        var ostream = Components.classes[FILE_OUTPUT_STREAM]
                              .createInstance(nsIFileOutputStream);

        // Then we open a channel to the RDF file in the JAR
        // out extension is sitting in....
        var jarRdfChannel = this.IOService().newChannel(
			"chrome://flipper/content/flipper.rdf",
			null,null);

        // Make a stream out of that channel...
	var jarRdfStream = jarRdfChannel.open();

        // ...and make a scriptable stream out of it!
        var scriptStream =
             Components.classes["@mozilla.org/scriptableinputstream;1"]
              .createInstance(Components.interfaces.nsIScriptableInputStream);
        scriptStream.init(jarRdfStream);

        // We get the contents from the RDF in the jar file
        // reading it in a  string buffer.
        var rdfLen = scriptStream.available();
        var rdfBuffer = scriptStream.read(rdfLen);
      
        // We now create the "flipper.rdf" file in the user
        // profile directory. 
        tempLocalFile.create(
                 Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 
                 0655);
        
        // Associate the output stream with the local file
        // we just created and dump the rdf buffer we read
        // in it.
        ostream.init(tempLocalFile, 0x02, 00644, 0);
        var retCode = 0;
        ostream.write(rdfBuffer, rdfLen, retCode);
        // We should be done!
        ostream.close();
        scriptStream.close();

      } catch (e) {
        alert("Error creating new RDF file: "+e);
      }
    }

    return (uri);

  },

  selected: function(event) 
  {
    oldurls = document.getElementById("oldurls");
    selitem = oldurls.selectedItem;
    try {
      selitemid = selitem.id.replace(/urn:Flip:/gi, '');
      urlBase = myRDF.getData(selitemid,"urlBase");
      urlGal = myRDF.getData(selitemid,"urlGal");
      urlMid = myRDF.getData(selitemid,"urlMid");
      urlImg = myRDF.getData(selitemid,"urlImg");
      urlEnd = myRDF.getData(selitemid,"urlEnd");
      mingal = myRDF.getData(selitemid,"minGal");
      maxgal = myRDF.getData(selitemid,"maxGal");
      minimg = myRDF.getData(selitemid,"minImg");
      maximg = myRDF.getData(selitemid,"maxImg");
      referrer = myRDF.getData(selitemid,"referrer");
      document.getElementById("referrerUrl").value = referrer;
      document.getElementById("beginUrl").value = urlBase;
      document.getElementById("gallSequence").value = urlGal;
      document.getElementById("middleUrl").value = urlMid;
      document.getElementById("imgSequence").value = urlImg;
      document.getElementById("closingUrl").value = urlEnd;
      document.getElementById("mingal").value = mingal;
      document.getElementById("maxgal").value = maxgal;
      document.getElementById("minimg").value = minimg;
      document.getElementById("maximg").value = maximg;
    } catch (e) { alert(e) };
  },

  delurl: function(event) 
  {
    oldurls = document.getElementById("oldurls");
    selitem = oldurls.selectedItem;
    selitemid = selitem.id.replace(/urn:Flip:/gi, '');
    myRDF.delData(selitemid);
    myRDF.flush();
    try {
      oldurls.builder.rebuild();
    } catch (e) { alert("Could not rebuild:\n\n"+e) }
    oldurls.selectedIndex = -1;
    this.clearForm();
  },

  initDialog: function ()
  {


      myUrlFlipper = window.arguments[0].objUrlFlipper;
      myBrowser = window.arguments[2];
      urlnow = document.getElementById("actualUrl");
      urlnow.value = window.arguments[1];
      urlreferr = document.getElementById("referrerUrl");
      urlreferr.value = window.arguments[0].getReferrer();

    var uri = this.getRdf();

      oldurls = document.getElementById("oldurls");
    try {
      var rdfService = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService);

      myDS = rdfService.GetDataSource(uri);
      var dsources = oldurls.database.GetDataSources();
      while ( dsources.hasMoreElements() ) {
        oldurls.database.RemoveDataSource(dsources.getNext());
      }
      oldurls.database.AddDataSource(myDS);
      try {
        oldurls.builder.rebuild();
      } catch(e) { alert("Error rebuilding:\n\n"+e); }
    } catch (e) { alert("Error adding datasource:\n\n"+e) };
      oldurls.selectedIndex = -1;

    try {
      myRDF= new rdfObject(uri, "Flip", "http://www.aliquam.org/flipper#"); 
    } catch (e) {
      alert(e);
    };

    setTimeout("flipperDialog.setPath();", 100);

  },


  setPath: function () {
    savepath = document.getElementById("saveto");
    savepath.value=myRDF.getData('root', 'path');
  },

  numformat: function(myrange, mynumber)
  {
     if ( myrange != 0 ) {
       tmpnum = mynumber.toString();
       while ( tmpnum.length < myrange ) {
         tmpstr = "0"+tmpnum;
         tmpnum = tmpstr;
       }
       return tmpnum;
     }
     else {
       return mynumber.toString();
     }
  },

  clearForm: function() {
    document.getElementById("beginUrl").value="";
    document.getElementById("gallSequence").value="";
    document.getElementById("middleUrl").value="";
    document.getElementById("imgSequence").value="";
    document.getElementById("closingUrl").value="";
    document.getElementById("mingal").value="";
    document.getElementById("maxgal").value="";
    document.getElementById("minimg").value="";
    document.getElementById("maximg").value="";
    document.getElementById("referrerUrl").value="";
  },

  buildFlipper: function()
  {
    urlBase = document.getElementById("beginUrl").value;
    urlGal = document.getElementById("gallSequence").value;
    urlMid = document.getElementById("middleUrl").value;
    urlImg = document.getElementById("imgSequence").value;
    urlEnd = document.getElementById("closingUrl").value;
    myUrlFlipper.setflipper(urlBase, urlGal,urlMid,urlImg,urlEnd);
    mingal = document.getElementById("mingal").value;
    maxgal = document.getElementById("maxgal").value;
    minimg = document.getElementById("minimg").value;
    maximg = document.getElementById("maximg").value;
    myUrlFlipper.setranges(mingal,maxgal,minimg,maximg);
    urlreferr = document.getElementById("referrerUrl");
    window.arguments[0].setReferrer(urlreferr.value);

    savepath = document.getElementById("saveto").value;
    window.arguments[0].setSavePath(savepath);
    saveit = document.getElementById("saveimg").checked;
    window.arguments[0].setSaveAction(saveit);
    autoflip = document.getElementById("autoflip").checked;
    window.arguments[0].setAutoFlip(autoflip);

    if ( urlBase != "" ) {
      try {
        var found = 0;
        var i = 0; 
        var maxno = 0;
        while ( !found && i<myRDF.length() ) {
          if ( urlBase == myRDF.getData(myRDF.item(i),"urlBase") ) {
            //alert("Found matching URL: <"
            //       +myRDF.getData(myRDF.item(i),"urlBase")
            //       +"> <"+urlBase+">");

            found = 1;
          }
          else {
            newno = parseInt(myRDF.item(i).replace(/item/gi,'')); 
            if ( newno > maxno )
              maxno = newno;
//            alert("URL No match! : <"
//                        +myRDF.getData(myRDF.item(i),"urlBase")
//                        +"> <"+urlBase+"> ("+maxno+")");
          }
         
          i++;
        }

        i--;

        if ( found ) {
          newitem = myRDF.item(i);
//          alert("Rewriting Item: "+newitem);
        }
        else {
          newitem = "item"+(maxno+1);
//          alert("New Item: "+newitem);
        }

        myRDF.setData(newitem,'urlBase',urlBase); 
        myRDF.setData(newitem,'urlGal',urlGal); 
        myRDF.setData(newitem,'urlMid',urlMid); 
        myRDF.setData(newitem,'urlImg',urlImg); 
        myRDF.setData(newitem,'urlEnd',urlEnd); 
        myRDF.setData(newitem,'minGal',mingal); 
        myRDF.setData(newitem,'maxGal',maxgal); 
        myRDF.setData(newitem,'minImg',minimg); 
        myRDF.setData(newitem,'maxImg',maximg); 
        myRDF.setData(newitem,'referrer',urlreferr.value); 
        myRDF.flush();

        nurl=urlBase+this.numformat(urlGal.length, mingal)
             +urlMid+this.numformat(urlImg.length, minimg)
             +urlEnd;

        nurl = window.arguments[0].replaceVars(nurl);

        window.arguments[0].loadImg(nurl);


      } catch (e) {
        alert(e);
      };
    }

 

    window.close();

  },

  cancel: function () {

    myRDF.flush();
    window.close();

  },

  getfolder: function() {
    
    savepath = document.getElementById("saveto");

    if ( savepath.value == "" ) {
      // get Home Directory
      const DIR = this.IProperties();
      var dir = DIR.get('Home', Components.interfaces.nsILocalFile);
      savepath.value = dir.path;
    }

    var picker = Components.classes["@mozilla.org/filepicker;1"]
                   .createInstance(Components.interfaces.nsIFilePicker);
    picker.init(window, "Choose download directory...", 
                    0x02);

    picker.appendFilters(Components.interfaces.nsIFilePicker.filterAll);

    var tempLocalFile = this.ILocalFile();
    tempLocalFile.initWithPath(savepath.value);

    picker.displayDirectory = tempLocalFile;

    if (picker.show() == Components.interfaces.nsIFilePicker.returnOK) {
      savepath.value=picker.file.path;
      myRDF.setData('root', 'path', picker.file.path);
      myRDF.hideData('root');
      myRDF.flush();
    }

  }

}

