
// Add the aliquam.org namespace to the window
if (!("aliquam" in window))
  window.aliquam = { org: { } };

aliquam.org.urlflipper = {

  urlbase: null,
  galrange: null,
  galvalue: null,
  urlmiddle: null,
  imgrange: null,
  urlend: null,
  maxgal: null,
  maximg: null,
  mingal: null,
  minimg: null,
  thisimg: null,
  thisgal: null,
  initialized: 0,
  alldone: false,

  isinitialized: function() {
    if ( initialized ) return 1;
    return 0;
  },
  
  isalldone: function() {
    return alldone;
  },

  clearalldone: function() {
    alldone = false;
  }, 

  setflipper: function(strbase,strgal,strmiddle,strimg,strend) {
    urlbase=strbase;
    galrange=strgal.length;
    galvalue=strgal;
    urlmiddle=strmiddle;
    imgrange=strimg.length;
    urlend=strend;
    initialized=1;
  },

  setranges: function(mingl,maxgl,minim,maxim) {
    maxgal=maxgl;
    mingal=mingl;
    maximg=maxim;
    minimg=minim;
    thisimg=minim;
    thisgal=mingl;
    initialized=1;
    alldone = 0;
  },

  numformat: function(myrange, mynumber)
  {
     if ( myrange != 0 ) {
       tmpnum = mynumber.toString();
       while ( tmpnum.length < myrange ) {
         tmpstr = "0"+tmpnum;
         tmpnum = tmpstr;
       }
       return tmpnum;
     }
     else {
       return mynumber.toString();
     }
  },

  charsub: function(strCounter)
  {
    var topped = 0;
    var nchar = strCounter.length;
    while ( !topped ) {
      if ( strCounter.charAt(nchar-1) != 'a' ) {
        strCounter = strCounter.substr(0,nchar-1)+String.fromCharCode(strCounter.charCodeAt(nchar-1)-1)+strCounter.substr(nchar, strCounter.length);
        topped=1;
      }
      else {
        if ( strCounter.length == 1 ) return 'a';
        if (nchar==1) {
          strCounter='z'+strCounter.substr(1,strCounter.length);
          topped=1;
        }
        else {
          strCounter=strCounter.substr(0,nchar-1)+'z'+strCounter.substr(nchar, strCounter.length);
          nchar--;
        }
      }
    }  

    return strCounter;
  },


  charadd: function(strCounter)
  {
    var topped = 0;
    var nchar = strCounter.length;
    while ( !topped ) {
      if ( strCounter.charAt(nchar-1) != 'z' ) {
        strCounter = strCounter.substr(0,nchar-1)+String.fromCharCode(strCounter.charCodeAt(nchar-1)+1)+strCounter.substr(nchar, strCounter.length);
        topped=1;
      }
      else {
        if (nchar==1) {
          strCounter='aa'+strCounter.substr(1,strCounter.length);
          topped=1;
        }
        else {
          strCounter=strCounter.substr(0,nchar-1)+'a'+strCounter.substr(nchar, strCounter.length);
          nchar--;
        }
      }
    }  

    return strCounter;
  },

  replaceVars: function(inString) {
    if ( inString.lastIndexOf('(') >= 0 ) {
      preOp = inString.substr(0, inString.lastIndexOf('('));
      postOp = inString.substr(inString.lastIndexOf(')')+1, inString.length);
      galOp =  inString.substr(inString.lastIndexOf('(')+1,
                 inString.lastIndexOf(')')-inString.lastIndexOf('(')-1);
      counters = galOp.split(",");
      cntidx = (thisgal % counters.length)-1;      
      if ( cntidx < 0 ) { cntidx = counters.length - 1; }
      inString = preOp+counters[cntidx]+postOp;
    }
    if ( inString.lastIndexOf('[') >= 0 ) {
      preOp = inString.substr(0, inString.lastIndexOf('['));
      postOp = inString.substr(inString.lastIndexOf(']')+1, inString.length);
      galOp =  inString.substr(inString.lastIndexOf('[')+1,
                 inString.lastIndexOf(']')-inString.lastIndexOf('[')-1);
      intDiff = parseInt(galOp);
      secNum = parseInt(thisgal) + intDiff;
      inString = preOp+this.numformat(galrange, secNum)+postOp;
    }
    inString = inString.replace(/--g--/, thisgal);
    inString = inString.replace(/--fg--/, this.numformat(galrange, thisgal));
    return inString;
  },

  galup: function() {


    thisimg = minimg;  

    try {
      if ( !parseInt(mingal) ) {
        if ( thisgal != maxgal ) {
          thisgal=this.charadd(thisgal);
        }
        else {
          thisgal = mingal;
          alldone = true;
        }      
        nurl=urlbase+thisgal+urlmiddle
             +this.numformat(imgrange,thisimg)+urlend; 
      }
      else {
        if ( parseInt(thisgal) >= parseInt(maxgal) ) {
          thisgal = mingal;
          alldone = true;
        }
        else {
          thisgal++;
        }
        nurl=urlbase+this.numformat(galrange, thisgal)
             +urlmiddle+this.numformat(imgrange,thisimg)+urlend;
      }    
   
 
      if ( galvalue != "-" ) {
        return this.replaceVars(nurl);
      }
      else {
        return this.replaceVars(urlbase+urlmiddle
                                +this.numformat(imgrange,thisimg)+urlend);
      }

    } catch(e) { alert("Error:\n"+e) }
  },

  galdown: function() {


    thisimg = minimg;

    if (!parseInt(mingal)) {
      if ( thisgal != mingal ) {
        thisgal=this.charsub(thisgal);
      }
      else {
        thisgal = maxgal;
      }      
      nurl=urlbase+thisgal+urlmiddle
           +this.numformat(imgrange,thisimg)+urlend;
    }
    else {
      if ( parseInt(thisgal) <= parseInt(mingal) ) {
        thisgal = maxgal;
      }
      else {
        thisgal--;
      }
      nurl=urlbase+this.numformat(galrange, thisgal)+urlmiddle
           +this.numformat(imgrange,thisimg)+urlend;
    }

   if ( galvalue != "-" ) {
      return this.replaceVars(nurl);
   }
   else {
      return this.replaceVars(urlbase+urlmiddle+this.numformat(imgrange,thisimg)+urlend);
   }


  },

  imgup: function() {

    if ( parseInt(thisimg) >= parseInt(maximg) ) {
      this.galup();
    }
    else {
      thisimg++;
    }

    if ( galvalue != "-" ) {
      nurl=urlbase+this.numformat(galrange, thisgal)+urlmiddle
                  +this.numformat(imgrange,thisimg)+urlend;
    }
    else {
      nurl=urlbase+urlmiddle
                  +this.numformat(imgrange,thisimg)+urlend;

    }
   
    return this.replaceVars(nurl);

  },

  imgdown: function() {


   
    if ( parseInt(thisimg) <= parseInt(minimg) ) {
      this.galdown();
      thisimg = maximg;
    }
    else {
      thisimg--;
    }

    if ( galvalue != "-" ) {
      nurl=urlbase+this.numformat(galrange, thisgal)+urlmiddle
                  +this.numformat(imgrange,thisimg)+urlend;
    }
    else {
      nurl=urlbase+urlmiddle
                  +this.numformat(imgrange,thisimg)+urlend;

    }

    return this.replaceVars(nurl);

  },

  currimg: function() 
  {
    
    if ( galval != "-" ) {
      return this.replaceVars(urlbase+
                              this.numformat(galrange, thisgal)+
                              urlmiddle+
                              this.numformat(imgrange,thisimg)+urlend);
    }
    else {
      return this.replaceVars(urlbase+
                              urlmiddle+
                              this.numformat(imgrange,thisimg)+urlend);
    }

  }  

};



aliquam.org.flipper = {

  objUrlFlipper:	aliquam.org.urlflipper, 
  thisbrowser: 		null,
  initialized:		0,
  referrerURI:		null,
  referrernsURI:	null,
  myObserver:		null,
  savePath:		null,
  saveAction:		false,
  autoFlip:		false,

  setSavePath:	function(saveto) {
    this.savePath = saveto;
  },

  setSaveAction: function(saveit) {
    this.saveAction = saveit;
  },

  setAutoFlip: function(autoflip) {
    this.autoFlip = autoflip;
  },

  tryFlip: function() {

    if (!this.isalldone() && this.autoFlip) 
       this.imgup();

  },

  trySave: function() {


    if (this.saveAction) {

      thisURI = Components.classes['@mozilla.org/network/standard-url;1']
                     .createInstance(Components.interfaces.nsIURI);
  
      thisURI.spec = this.currImg();
  
      newDir = Components.classes['@mozilla.org/file/local;1']
                  .createInstance(Components.interfaces.nsILocalFile);

      try {
  
        newConstIFile = new Components.Constructor('@mozilla.org/file/local;1', "nsILocalFile", "initWithPath");
        newIFile = newConstIFile(this.savePath);
        newIFile.append(thisURI.host);
        addPath = thisURI.path.substr(0, thisURI.path.lastIndexOf('/'));
        fName = thisURI.path.substr(thisURI.path.lastIndexOf('/')+1);
        patharr = addPath.split("/");

        /*  Original version - too many folders to go into!
        for ( i = 0 ; i < patharr.length ; i++ )
          newIFile.append(patharr[i]);
        */ 

        var prefix = "";
        for ( i = 0 ; i < patharr.length ; i++ )
          prefix = prefix + patharr[i];
        fName = prefix + fName;
        
        newDir.initWithPath(newIFile.path);
        if ( !newDir.exists() ) 
          newDir.create(newDir.DIRECTORY_TYPE, 509);
          
      } catch (E) { alert("Error creating dir "+newIFile.path+" : \n"+E) }

      newIFile.append(fName);
      newDir.initWithPath(newIFile.path);

      referURI = Components.classes['@mozilla.org/network/standard-url;1']
                     .createInstance(Components.interfaces.nsIURI);
  
      referURI.spec = referrerURI;

      wbp = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);

      wbp.saveURI(thisURI, null, referURI, null, null, newDir);

     }

  },

  getReferrer: function()
  {
    return referrerURI;
  },
  
  setReferrer: function(refURI)
  {
    try {
      referrerURI = refURI;
      referrernsURI.spec = refURI;
    } catch(e) { alert("Setting referrer:\n\n"+e); }
  },

  
  httpobserver: function()
  {

    return {

      httpResult: null,
      direction:  null,
      flipper:	  null,
      reloading:  null,

      cancelRequests: function(httpRequest) {

        myEnum = httpRequest.loadGroup.requests;
        while ( myEnum.hasMoreElements() ) {
         thisReq =  myEnum.getNext()
                        .QueryInterface(Components.interfaces.nsIRequest);
         thisReq.cancel(Components.results.NS_BINDING_ABORTED);
        }

      },
      
      observe: function(subject, topic, data) {

        httpChan = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
        httpReq = subject.QueryInterface(Components.interfaces.nsIRequest);
        uriName = httpReq.name;
        


        if ( topic == "http-on-examine-response" ) {
        	

          obService = Components.classes['@mozilla.org/observer-service;1']
                         .getService(Components.interfaces.nsIObserverService);
          obService.removeObserver(this,"http-on-modify-request" , false);
          obService.removeObserver(this,"http-on-examine-response" , false);

          this.httpResult = httpChan.responseStatus;

          if ( this.httpResult > 299 && this.httpResult != 304   ) {

            try {
              this.cancelRequests(httpReq);
              this.cancelRequests(httpChan);
            } catch(e) {  }

            if ( this.direction == 1 ) { 
              if ( !this.flipper.isalldone() )
                this.flipper.galup();
              return Components.results.NS_OK;
            }

            if ( this.direction == 0 ) { 
              this.flipper.galdown();
              return Components.results.NS_OK;
            }
       
            if ( this.direction == 3 ) { 
              if ( !this.flipper.isalldone() ) {
                this.flipper.imgup();
              }
              return Components.results.NS_OK;
            }

            if ( this.direction == 2 ) { 
              this.flipper.imgdown();
              return Components.results.NS_OK;
            }

            alert("Here??"); 
            return Components.results.NS_OK;
          }
          else {
            this.flipper.trySave();
            this.flipper.tryFlip();
          }

          return Components.results.NS_OK;

        }
     
        if ( topic == "http-on-modify-request" ) {
          httpChan.redirectionLimit = 0;
        }

        return Components.results.NS_OK;

      }

    };

  },

  createObs: function() {

      try {

        myObs = this.httpobserver();
       
        myObs.flipper = this;
  
        return myObs;

      } catch(e) { alert("Error creating observer:\n\n"+e); }

  },

  
  activateObs: function() {
        
  	try {
          var obService = Components.classes['@mozilla.org/observer-service;1'].getService();
          obService = obService.QueryInterface(Components.interfaces.nsIObserverService);
          resTopic = "http-on-examine-response";
          modTopic = "http-on-modify-request";
          obService.addObserver(this.myObserver, modTopic, false);
          obService.addObserver(this.myObserver, resTopic, false);
          
	} catch (E) { alert("Error activating observer:\n"+E); }
  },

  init: function ()
  {
      try {
        thisbrowser = document.getElementById("content").selectedBrowser;
        actualUrl = thisbrowser.webNavigation.currentURI.spec;
        myHistory = thisbrowser.sessionHistory;
        lastEntryIdx = (myHistory.index)-1;

        referrernsURI = Components.classes['@mozilla.org/network/standard-url;1']
                     .createInstance(Components.interfaces.nsIURI);

        if ( lastEntryIdx >= 0 ) {
          referrerURI = myHistory.getEntryAtIndex(lastEntryIdx, false).URI.spec;
        }
        else referrerURI="http://";

        this.setReferrer(referrerURI);

        this.myObserver = this.createObs();

        openDialog("chrome://flipper/content/flipper.xul", "Flipper Init",
                   "chrome,resizable=yes,dependent=yes", 
                   this, actualUrl, thisbrowser);
      } catch(e) { alert("Error during init:\n\n"+e); } 
  },

  replaceVars: function(inString) {
    return this.objUrlFlipper.replaceVars(inString);
  },

  galup: function ()
  {

      this.activateObs(); 

      wantURL = this.objUrlFlipper.galup();
      this.myObserver.direction=1;
      thisbrowser.webNavigation.stop(1);
      thisbrowser.webNavigation.loadURI(wantURL, 16,referrernsURI,null,null);
  },

  isalldone: function() {
      return this.objUrlFlipper.isalldone();
  },

  galdown: function ()
  {

      this.activateObs(); 

      this.objUrlFlipper.clearalldone();
      wantURL = this.objUrlFlipper.galdown();
      this.myObserver.direction=0;
      thisbrowser.webNavigation.stop(1);
      thisbrowser.webNavigation.loadURI(wantURL, 16,referrernsURI,null,null);
  },

  imgup: function ()
  {

      this.activateObs(); 

      wantURL = this.objUrlFlipper.imgup();
      this.myObserver.direction=3;
      thisbrowser.webNavigation.stop(1);
      thisbrowser.webNavigation.loadURI(wantURL, 16,referrernsURI,null,null);
  },

  imgdown: function ()
  {

      this.activateObs(); 

      this.objUrlFlipper.clearalldone();
      wantURL = this.objUrlFlipper.imgdown();
      this.myObserver.direction=2;
      thisbrowser.webNavigation.stop(1);
      thisbrowser.webNavigation.loadURI(wantURL, 16, referrernsURI,null,null);
  },

  loadImg: function(wantURL) {
      this.activateObs(); 
      this.myObserver.direction=1;
      thisbrowser.webNavigation.loadURI(wantURL, 16, referrernsURI,null,null);
  },

  currImg: function() {
    return this.objUrlFlipper.currimg();
  },

  reloadImg: function() {
      this.myObserver.direction=1;
      this.activateObs(); 
      wantURL = this.objUrlFlipper.currimg();
      thisbrowser.webNavigation.loadURI(wantURL, 16, referrernsURI,null,null);
  }
  
}



myFlipper = aliquam.org.flipper;

